// global constants
var gc_sImgMinus = "minus.png";
var gc_sImgPlus = "plus.png";
var gc_sWidth = "9";
var gc_sHeight = "9";
//-------------------------------------------------------------------------------------------------
function showTag(tag)
{
 	tag.style.setProperty("display", "block", null);
}
//-------------------------------------------------------------------------------------------------
function hideTag(tag)
{
 	tag.style.setProperty("display", "none", null);
}
//-------------------------------------------------------------------------------------------------
// return next sibling of tag ignoring text nodes
function LookupNextSibling(tag)
{
	tag = tag.nextSibling;
	if (tag != null)
	{
		while (tag.nodeType == 3) 
		{ 	// Fix for Opera/FireFox Empty Space becomes a TextNode 
			tag = tag.nextSibling;
		}
	}
	
	return tag;
}
//-------------------------------------------------------------------------------------------------
// toggle (hide/show) comment text of sender and all the nested comments
// func -- function that perform actions on tags -- specifies action: hide/show
function ToggleTags(sender, func)
{
	var li = sender.parentNode;
	var ul = li.parentNode;
	var divMsgMeta = ul.parentNode;
	var divEntryContent = LookupNextSibling(divMsgMeta);
 	func(divEntryContent);
	var divReplyForm = LookupNextSibling(divEntryContent);
	func(divReplyForm);
	var ulChilds = LookupNextSibling(divReplyForm);
	if (ulChilds != null)
	{
		func(ulChilds);
	}
}
//-------------------------------------------------------------------------------------------------
// sender -- <img> placeholder with minus/plus .png source
function habrCollapseComments(sender)
{
	sender.setAttribute("src", gc_sImgPlus);
	sender.setAttribute("class", "habr_plusminus habr_plus");

	ToggleTags(sender, hideTag);
}
//-------------------------------------------------------------------------------------------------
// sender -- <img> placeholder with minus/plus .png source
function habrExpandComments(sender)
{
	sender.setAttribute("src", gc_sImgMinus);
	sender.setAttribute("class", "habr_plusminus habr_minus");

	ToggleTags(sender, showTag);
}
//-------------------------------------------------------------------------------------------------
// sender -- <img> placeholder with minus/plus .png source
// 
// returns true if action: collapse
// false otherwise
function IsCollapse(sender)
{
	return (sender.getAttribute("src") == gc_sImgMinus);
}
//-------------------------------------------------------------------------------------------------
// toggle (hide/show) comment text of sender and all the nested comments
//
// sender -- <img> placeholder with minus/plus .png source
// which is actually fires the onClick event
function habrToggleComments(sender)
{
	if (IsCollapse(sender))
	{
		habrCollapseComments(sender);
	}
	else
	{
		habrExpandComments(sender);
	}
}
//-------------------------------------------------------------------------------------------------
// returns all the child nodes of rootNode with class containing sSearchClass and tag name sTag
// if sTag is null assumes that sTag is div
function getTagsByClass(sSearchClass, rootNode, sTag) 
{
	if ( rootNode == null )
		rootNode = document;
	if (sTag == null)
		sTag = "div";

	var arClassDivs = new Array();
	var arAllDivs = rootNode.getElementsByTagName(sTag);
	var nNumOfDivs = arAllDivs.length;
	var pattern = new RegExp( "(^|\\s)" + sSearchClass + "(\\s|$)" );
	for (i = 0, j = 0; i < nNumOfDivs; i++) 
	{
		if ( pattern.test(arAllDivs[i].className) ) 
		{
			arClassDivs[j] = arAllDivs[i];
			j++;
		}
	}

	return arClassDivs;
}
//-------------------------------------------------------------------------------------------------
function setEventHandler(control, eventType, handlerFunc)
{
	if (control.attachEvent)
	{
		control.attachEvent ("on" + eventType, handlerFunc);
	}

	if (control.addEventListener)
	{
		control.addEventListener (eventType, handlerFunc, false);
	}
}
//-------------------------------------------------------------------------------------------------
// add a minus button to each comment head
function habrSetupMinusPlusHandlers()
{
	var elComments = document.getElementById("comments")
	var arPostHeadDivs = getTagsByClass("msg-meta", elComments, null);
	if (arPostHeadDivs != null) 
	{
		var nLen = arPostHeadDivs.length;
		if (nLen > 0)
		{
			for ( i = 0; i < nLen; i++)
			{
				var arUl = arPostHeadDivs[i].getElementsByTagName("ul");
				var li = document.createElement("li");
				var li_img = document.createElement("img");
				li_img.setAttribute("src", gc_sImgMinus);					// placeholder for event
				li_img.setAttribute("alt", "");
				li_img.setAttribute("width", gc_sWidth);
				li_img.setAttribute("heght", gc_sHeight);

				li_img.setAttribute("class", "habr_plusminus habr_minus"); 	// actual picture
				li_img.setAttribute("onClick", "habrToggleComments(this);" );
				
				li.appendChild(li_img);

				arUl[0].insertBefore(li, arUl[0].getElementsByTagName("li")[0] );
			}
		}
	}
}
//-------------------------------------------------------------------------------------------------
// setup button addition function as an onLoad event handler for document
setEventHandler(document, "Load", habrSetupMinusPlusHandlers);
